
public class Grinch {
	
	public static Haus[] stadt;

	private int restzeit = 80;
	
	private Geschenk[] geklauteGeschenke = new Geschenk[0];
	
	/**
	 * Lässt den Grinch seine Diebestour beginnen.
	 */
	public void aufTourGehen() {
		// hier anfangen, die Häuser auszuräumen 
		
		for (int i=0;i<stadt.length;i++) {
			Haus haus = stadt[i];
			Geschenk[] geschenke = haus.ausraeumen();
			int zeit = (int) Math.ceil(geschenke.length / 10);
			
			this.restzeit -= zeit; // Restzeit um aktuellen Raubzug verkürzen
			if (this.restzeit < 0) {
				break; // aufhören
			}
			
			// wenn noch in der Zeit, Geschenke einsacken
			this.einsacken(geschenke);
		}
		
	}
	
	/**
	 * Fügt den Inhalt eines Geschenke-Arrays dem internen Datenmodell hinzu
	 * @param neue Die Liste mit den neuen Geschenken.
	 */
	public void einsacken (Geschenk[] neue) {
		Geschenk[] ergebnis = new Geschenk[this.geklauteGeschenke.length + neue.length];
		
		for (int i=0; i<this.geklauteGeschenke.length; i++) {
			ergebnis[i] = this.geklauteGeschenke[i];
		}
		for (int i=0; i<neue.length; i++) {
			ergebnis[i + this.geklauteGeschenke.length] = neue[i];
		}
		
		this.geklauteGeschenke = ergebnis;
	}
	
	/**
	 * Gibt auf der Kommandozeile aus, wie viel der Grinch geklaut hat.
	 */
	public void inventur () {
		int gesGew = 0;
		for (int i=0;i<this.geklauteGeschenke.length;i++) {
			gesGew += this.geklauteGeschenke[i].gewicht;
		}
		
		System.out.println("Der Grinch hat in "+(80-this.restzeit)+" Stunden "+this.geklauteGeschenke.length+" Geschenke mit "+gesGew+" Kilo Gesamtgewicht geklaut.");
	}
	

	public static void main(String[] args) {
		// mit dieser Methode können Sie nachher Ihre Implementierung testen:
		test();
	}
	
	public static void test() {
		stadt = new Haus[12];
		for(int i=0;i<stadt.length;i++) {
			stadt[i] = new Haus();
		}
		
		Grinch grinch = new Grinch();
		
		grinch.aufTourGehen();
		grinch.inventur();
	}
	
	/**
	 * Zugriff auf den aktuellen Wert der Restzeit
	 * @return
	 */
	public int getRestzeit () {
		return this.restzeit;
	}

}
